; everything (except vision <- untested) works on emu now

; swampy command line:
; D:\dev\VM\VMU_All_Stars\games>LCdis SWAMPY.VMS ENTRY0x1129 ENTRY0x1155 ENTRY0x1188 ENTRY0x11ff ENTRY0x1273 ENTRY0x1280 ENTRY0x12ae ENTRY0x12c6 ENTRY0x1364 > SWAMPY_2.s	

; todo:
; check pcon to enable more power savings in common.s

; bugs:

; testing on real VM:
; different to emu:
; working: swampy, paper, fatrain
; not working: 4wins, sketch
; furthermore:
; - sleep up not working, except in swampy, fatrain, paper, minesweeper, snaky?
;	? p3 button interrupt code is misaligned
;		-> fixed
; - messed up icon
;	? took wrong icon, due to include directories?
;		-> fixed, changed name: rbicon.i



; vision: freeze in game
;	-> game variable overwritten? -> interrupt not called?
;		..doesn't seem to be the reason
; !!! found problem: some data seems to be placed at 0xd9b,
; but it got no label assigned, so it's position must be hardcoded somewhere
; works with: .org $d9b
; ATTENTION: at d9b is a pointer table with TRL and TRH values
;	points to data of 2 bytes per unit
; okay, started to insert dynamic labels, but trying .org workaround first
; !!! does not work, again when all games are in
; okay, got it working, but in-game display only works, after switching off sound with B
;	-> maybe location of variable game, because after changing location, it doesn't work, again
;		- !!! yes it is, making an unconditional jump to visions interrupt handler works
;		! but there must be another reason, too. It worked only as standalone


; paper: freeze on ship crash
; LCdis command line:
; D:\dev\VM\VMU_All_Stars\games>LCdis PAPER.VMS ENTRY0x1115 ENTRY0x11f7 ENTRY0x1223 ENTRY0x1256 ENTRY0x12cd ENTRY0x137c ENTRY0x1432 ENTRY0x18b5 > PAPER_2.s	
; what's at 0x1321?

; !!! fatrain can freeze, too
; Both freeze with a single pixel being drawn wrong

; snaky: wrong GFX, some pixels are not cleared
;	? but it worked standalone
;	-> maybe an alignment issue?	
;WARNING: NOT1 EXT,0 encountered at unexpected address 0a61.
;         This code calls a routine in the firmware and the return address
;         is unknown (not in FIRMWARECALL table).
;WARNING: NOT1 EXT,0 encountered at unexpected address 05e0.
;         This code calls a routine in the firmware and the return address
;         is unknown (not in FIRMWARECALL table).
;	-> found some unrecognized code behind NOT1 EXT,0
;		-> obviously, you can call the bios from everywhere
;		-> added ENTRYs to LCdis commandline:
;D:\dev\VM\VMU_All_Stars\games>LCdis SNAKY.VMS ENTRY0x0a61 ENTRY0x05e0 > SNAKY_2.s
;	-> modified handling of writeflash line 730
; !!!! finally works, I deleted zero bytes which in fact where used as an empty screen image
;	just like clrscr
;	hint: L0500 and clrscr replacement wastes memory

; removed bugs

; spaceinvaders: swapped colors in game
;	-> NO, it is randomly choosen by game

; minesweeper doesn't react on input in title
;	-> keypress timer interrupt dispatcher was wrong
; new problem: freeze at name input screen
;	-> because memory $FF is overwritten by flashrom data
;	trying $79, works


; games per screen:
;	
;	screen 1: fatrain, tetris, spaceinvaders, paper
;
;	screen 2: swampy, slidepuzzle, 4wins, logic
;
;	screen 3: minesweeper, vision, bounce
;
;	screen 4: idoudo, sketch, snaky



	.include "sfr.i"

	;; Game variables

	.include "tetris_def.i"
	.include "minesweeper_def.i"
	.include "sketch_def.i"
	.include "idoudo_def.i"
	.include "spaceinvaders_def.i"
	.include "slidepuzzle_def.i"
	.include "snaky_def.i"
	.include "4wins_def.i"
	.include "logic_def.i"
;	.include "vision_def.i"
	.include "fatrain_def.i"
	.include "paper_def.i"
	.include "swampy_def.i"
	.include "bounce_def.i"

; this must not be overwritten by the games
; $80-$FF used by minesweeper for flashrom writing
;game				equ	$70
;game				equ	$80
game				equ	$79


; games which don't use the game varaible can take a dummy bit
game_dummy			equ	0
game_tetris			equ	0
game_slidepuzzle	equ 0
game_snaky			equ 0
game_logic			equ 0
game_bounce			equ 0


game_idoudo			equ 1
game_spaceinvaders	equ 2
game_minesweeper	equ	3
game_4wins			equ 4
game_vision			equ 5
game_fatrain		equ 6
game_paper			equ 6
game_swampy			equ 6
game_sketch			equ 7


        ;; bits in keys
pressed_sleep   equ     7       ; same like port 3, if 0: button pressed
pressed_mode    equ     6
pressed_b       equ     5
pressed_a       equ     4
pressed_right   equ     3
pressed_left    equ     2
pressed_down    equ     1
pressed_up      equ     0

; global seed, used by tetris and sketch
seed = $3c			; random seed

	;; Reset and interrupt vectors
	
; reset
	.org	0
	jmpf	start

; external irq 0
	.org	$3
	bn game, game_fatrain, .skip_fat
	CLR1   I01CR, 1
.skip_fat:	
	jmp	nop_irq

; external irq 1
	.org	$b
	jmp	nop_irq
	
; timer/counter 0 low 8 bit mode overflow
	.org	$13
	jmpf	int_13

; count clock
	.org	$1b
	jmpf	int_1b

	
; timer/counter 0 high / 16 bit mode overflow
	.org	$23
	jmpf	int_23


; timer/counter 1 overflow
	.org	$2b
	jmpf	int_2b

; SIO0
	.org	$33
	jmpf	nop_irq

; SIO1
	.org	$3b
	jmp	nop_irq

; RFB
	.org	$43
; changed: actually in the games of Omar Cornut,
; there is 4 times "SET1   $1ff, 7"	and a fall through
	bp game, game_fatrain, .skip_nofat	
	jmp	nop_irq
.skip_nofat:
	SET1   $1ff, 7
; no space for these, they may be redundant either
;	SET1   $1ff, 7
;	SET1   $1ff, 7


; port3 change: key pressed
	.org	$4b
	clr1	p3int,p3iflag		; clear flag
	bp game, game_4wins, nop_irq
	bp game, game_fatrain, nop_irq
	clr1	p3int,p3ie		; disable further interrupts
nop_irq:
	reti
	
;;; minesweeper {

; Firmware calls

	.org	$100
writeflash
	not1	ext,0
	jmpf	writeflash
	ret

	.org	$110
verifyflash
	not1	ext,0
	jmpf	verifyflash
	ret

	.org	$120
readflash
	not1	ext,0
	jmpf	readflash
	ret

;;; } minesweeper


; Clock irq: Count time, do housekeeping
	.org	$130
	
int_1b:
	push	ie
	clr1	ie,mastie
	not1	ext,0
	jmpf	int_1b
;	bn game, game_vision, .skip_v
; 	jmpf		L0139
;.skip_v	
	pop	ie
	bn game, game_minesweeper, .skip_m
	callf	myclockint
.skip_m:
	reti
		
; Leave game
	.org	$1f0
goodbye:	
	not1	ext,0
	jmpf	goodbye


; Header
	.org	$200
; Name
	.byte	"VMU All Stars #1"      ; 16 letters
; Description
	.byte	"VMU All Stars #1 www.rockin-b.de"      ; 32 letters
; Creator application
	.byte	"aslc86k         "

	;; Icon header
	
	.org	$240
; Icon header: number of frames
	.word	3
; Icon header: speed
	.word	10
; Icon header: eyecatch
	.word	0
; Icon header: crc, unused in game
	.word	0
; Length of file data
	.word	end,0
; Reserved
	.byte	0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0

	;; Icon palette
	
	.org	$260

	.word	$F000,$F800,$F080,$F880,$F008,$F808,$F088,$FCCC
	.word	$F888,$FF00,$F0F0,$FFF0,$F00F,$FF0F,$F0FF,$FFFF

	;; The "Rockin'-B" icon for VMU file browser on Dreamcast 

	.org	$280

	.include "rbicon.i"
	
	;; Main program

	.org	$680

start:

;	jmpf start2
;	.include "vision_game.s"
;	.include "vision_data.i"
;start2:
		clr1	ie,mastie	; disable all irq

		mov	#$a1,ocr	; speed control, subclock active, no div 2
		mov	#$09,mcr	; LCD on, no cursor, gfx mode
		mov	#$80,vccr	; LCD on, enable writing
		clr1	p3int,p3ie	; disable P3 irq
		clr1	p1,7		; ???
		mov	#$ff,p3		; enable pull-ups on P3 (buttons)

		set1	ie,mastie	; enable all irq

	    ;; then wait for the user's choice
		xor acc
		st game

scr_0:
 		mov #<(screen_0+2),trl
 		mov #>(screen_0+2),trh
		callf setscr
.waitrelease:
        callf getkeys
        bne #%11111111, .waitrelease
.wait:
        callf getkeys
        be #%11111111, .wait
	; change screen?	
        bp acc, pressed_b, .skip_b
        jmpf scr_1
.skip_b:        
        bp acc, pressed_a, .skip_a
		jmpf scr_4
.skip_a:		
        br .wait






        ;; start game according to user's choice
scr_1:
		mov #<(screen_1+2),trl
		mov #>(screen_1+2),trh
		callf setscr
.waitrelease:
        call getkeys
        bne #%11111111, .waitrelease
.wait:
        call getkeys
        be #%11111111, .wait

	; change screen?	
        bn acc, pressed_b, scr_2
        bp acc, pressed_a, .skip_a
        jmpf scr_0
.skip_a:        
    ; select game?
        bp acc, pressed_left, .skip_left
        set1 game, game_fatrain
        jmpf fatrain
.skip_left:
        bp acc, pressed_right, .skip_right
        set1 game, game_tetris
        jmpf tetris
.skip_right:
        bp acc, pressed_up, .skip_up
        set1 game, game_spaceinvaders
        jmpf spaceinvaders
.skip_up:
        bp acc, pressed_down, .skip_down
        set1 game, game_paper
        jmpf paper
.skip_down:
        br .wait

scr_2:	
		mov #<(screen_2+2),trl
		mov #>(screen_2+2),trh
		callf setscr
.waitrelease:
        call getkeys
        bne #%11111111, .waitrelease
.wait:
        call getkeys
        be #%11111111, .wait

	; change screen?	
        bn acc, pressed_b, scr_3
        bn acc, pressed_a, scr_1
    ; select game?
        bp acc, pressed_left, .skip_left
        set1 game, game_swampy
        jmpf swampy
.skip_left:
        bp acc, pressed_right, .skip_right
        set1 game, game_slidepuzzle
        jmpf slidepuzzle
.skip_right:
        bp acc, pressed_up, .skip_up
        set1 game, game_4wins
        jmpf fourwins
.skip_up:
        bp acc, pressed_down, .skip_down
        set1 game, game_logic
        jmpf logic
.skip_down:
        br .wait

scr_3:	
		mov #<(screen_3+2),trl
		mov #>(screen_3+2),trh
		callf setscr
.waitrelease:
        call getkeys
        bne #%11111111, .waitrelease
.wait:
        call getkeys
        be #%11111111, .wait

	; change screen?	
        bn acc, pressed_b, scr_4
        bn acc, pressed_a, scr_2
    ; select game?
        bp acc, pressed_left, .skip_left
        set1 game, game_minesweeper
        jmpf minesweeper
.skip_left:
        bp acc, pressed_right, .skip_right
;        set1 game, game_vision
;        jmpf vision
.skip_right:
        bp acc, pressed_up, .skip_up
        set1 game, game_bounce
        jmpf bounce
.skip_up:
        bp acc, pressed_down, .skip_down
.skip_down:
        br .wait

scr_4:	
		mov #<(screen_4+2),trl
		mov #>(screen_4+2),trh
		callf setscr
.waitrelease:
        call getkeys
        bne #%11111111, .waitrelease
.wait:
        call getkeys
        be #%11111111, .wait

	; change screen?	
        bp acc, pressed_b, .skip_b
		jmpf scr_0
.skip_b:
        bn acc, pressed_a, scr_3
    ; select game?
        bp acc, pressed_left, .skip_left
        set1 game, game_idoudo
        jmpf idoudo
.skip_left:
        bp acc, pressed_right, .skip_right
        set1 game, game_sketch
        jmpf sketch
.skip_right:
        bp acc, pressed_up, .skip_up
        set1 game, game_snaky
        jmpf snaky
.skip_up:
        bp acc, pressed_down, .skip_down
.skip_down:
        br .wait




;;	interrupt dispatcher

int_13:
	bn game, game_minesweeper, .skip_m
	jmpf	timer0l_irq
.skip_m:
	reti

int_23:
	bn game, game_fatrain, .skip_fat
	CLR1   T0CON, 3
.skip_fat:	
	bn game, game_minesweeper, .skip_m
	jmpf	timer0h_irq
.skip_m:
	reti

int_2b:
	bn game, game_minesweeper, .skip_m
	jmpf	sound_irq
.skip_m:
	reti

	.include "common.s"


	.include "minesweeper_game.s"
	.include "tetris_game.s"
	.include "sketch_game.s"
	.include "idoudo_game.s"
	.include "spaceinvaders_game.s"
	.include "slidepuzzle_game.s"
	.include "snaky_game.s"
	.include "4wins_game.s"
	.include "logic_game.s"
	.include "fatrain_game.s"
	.include "paper_game.s"
	.include "swampy_game.s"
	.include "bounce_game.s"


	.include "tetris_data.i"
	.include "minesweeper_data.i"
	.include "sketch_data.i"
	.include "idoudo_data.i"
	.include "spaceinvaders_data.i"
	.include "slidepuzzle_data.i"
	.include "snaky_data.i"
	.include "4wins_data.i"
	.include "logic_data.i"
	.include "fatrain_data.i"
	.include "paper_data.i"
	.include "swampy_data.i"
	.include "bounce_data.i"


 	.include "screen_0.i"
	.include "screen_1.i"
	.include "screen_2.i"
	.include "screen_3.i"
	.include "screen_4.i"

	.cnop	0,$200		; pad to an even number of blocks
end
