getkeys:
	bp p7,0,quit	; external 5VOLT ?
	ld p3			; p3(Keys) into ACC
	bn game, game_idoudo, .skip_idoudo
 	CALLF	getbuff
.skip_idoudo:	
	bn acc,6,quit	; MODE-key
	bn acc,7,sleep	; SLEEP-key
	ret

quit:
    jmpf goodbye
	
sleep:
; from sketch:
	set1 pcon,0         ; Enter HALT mode for a bit of time (save power)
	bn p3,7,sleep	; Wait for SLEEP to be depressed
	mov #0,vccr	; Blank LCD

sleepmore:
	set1 pcon,0	; Enter HALT mode
	bp p7,0,quit	; Docked?
	bp p3,7,sleepmore	; No SLEEP press yet
	mov #$80,vccr	; Reenable LCD

waitsleepup:
; from sketch:
	set1 pcon,0         ; Enter HALT mode for a bit of time (save power)
	bn p3,7,waitsleepup
	br getkeys


	;; Function:	clrscr (merged Marcus and Soeren's code)
	;;
	;; Clears the screen
clrscr:	
	push	ocr		; store oscillator
	clr1	ocr,subclk	; we access screen, no more subclock
	push	acc
	push	xbnk
	push	2		; used as counter
	mov	#0,xbnk		; LCD bank 0
.cbank: mov	#$80,2		; init counter
.cloop: mov	#0,@R2		; clear byte in LCD ram
	inc	2		; advance counter
	ld	2		; get counter
	and	#$f		; test for end of even row
	bne	#$c,.cskip	; no, continue
	ld	2		; end of even row, get counter
	add	#4		; start of next row
	st	2		; put counter
.cskip:	ld	2		; get counter
	bnz	.cloop		; test for end of LCD bank
	bp	xbnk,0,.cexit	; skip to end if last LCD bank
	mov	#1,xbnk		; continue in LCD bank 1
	br	.cbank		; start again
.cexit:	pop	2		; restore R2
	pop	xbnk
	pop	acc
	pop	ocr		; restore oscillator
	ret


	
	;; Function:	setscr
	;;
	;; Copies a predefined full-screen image to the screen
	;;
	;; Inputs:
	;;   trl = low byte of predefined screen ROM address
	;;   trh = high byte of predefined screen ROM address
	
setscr:
	push ocr ; changed
	clr1 ocr,5
	push acc
	push xbnk
	push c
	push 2
	mov #$80,2
	xor acc
	st xbnk
	st c
.sloop:	ldc
	st @R2
	inc 2
	ld 2
	and #$f
	bne #$c,.sskip
	ld 2
	add #4
	st 2
	bnz .sskip
	inc xbnk
	mov #$80,2
.sskip:	inc c
	ld c
	bne #$c0,.sloop
	pop 2
	pop c
	pop xbnk
	pop acc
	pop ocr		; changed	set1 ocr,5
	ret

	;; Function:	random
	;;
	;; Generates a pseudo-random value in the range 0-255
	;;
	;; Inputs:
	;;   seed = previous random seed
	;;
	;; Outputs:
	;;   seed = new random seed
	;;   acc  = generated random value

random:
	push b
	push c
	ld seed
	st b
	mov #$4e,acc
	mov #$6d,c
	mul
	st b
	ld c
	add #$39
	st seed
	ld b
	addc #$30
	pop c
	pop b
	ret

