;---------------
;Sub MAIN (program begins here!)
;---------------
logic:
;REQUIRED
 clr1 ie,7
 mov #$a1,ocr
 mov #$09,mcr
 mov #$80,vccr
 clr1 p3int,0
 clr1 p1,7
 mov #$ff,p3
 set1 ie,7
;Clear the screen
 call logic_clrscr
;Draw the LOGIC logo
 mov #>logo, ghp
 mov #<logo, glp
 mov #1, row
 mov #3, col
 mov #7, height
 mov #3, width
 mov #0, offset
 mov  #0,  xbnk
 callf draw_graphic
;Create the random pattern
 callf resetblock
;Set the TURN to 1 (first turn)
 mov #1, turn
;Game Loop
iloop:
;Make the selected block blink
 ld blinkstate
 add #1
 st blinkstate
 bne  #2, AAAAAAAAAA
 mov #0, blinkstate
AAAAAAAAAA:
;Delay the blinking slightly
 set1 ocr,5
 mov #30, acc
BAAAAAAAAA:
 dbnz acc, BAAAAAAAAA
 clr1 ocr,5
;Draw the selected block
 mov #block,0
 ld  selected
 add 0
 st 0
 ld @R0
 st temp
 ld selected
 add #2
 st temp2
 mov #>shapes, ghp
 mov #<shapes, glp
 ld temp2
 st row
 ld turn
 st col
 ld temp
 st shape
 mov  #3,  height
 callf drawshape
;Handle the keys
 callf get_keys
 brf iloop
 jmpf goodbye
 ret
 
logic_clrscr:
 clr1 ocr,5
;Clear top half of screen
 mov #0, xbnk
 call clrhalf
;Clear bottom half of screen
 mov #1, xbnk
 call clrhalf
 ret
clrhalf:
;Sub to clear all 6 bytes of all 16 rows of
;the upper or lower LCD screen (selected with 'xbnk')
 mov #0, row
CAAAAAAAAA:
 mov #0, c
 ld row
 mov #$2,b
 div
 mov #$10,b
 mul
 add #$80
 st baseadd
 clr1 acc,3
 be baseadd,DAAAAAAAAA
 clr1 baseadd, 3
 not1 baseadd, 1
 not1 baseadd, 2
DAAAAAAAAA:
 mov #0, col
EAAAAAAAAA:
 ld baseadd
 st 2
 ld col
 add 2
 st 2
 mov  #0, @R2
 ld col
 add  #1
 st col
 bne #6, EAAAAAAAAA
 ld row
 add  #1
 st row
 bne #16, CAAAAAAAAA
 ret
resetblock:
;Get random seed from the SECONDS system variable
 push psw
 clr1 psw, 1
 ld $1d
 pop psw
 st logic_seed
;Store loopvar in stack
 push loopvar
 mov #0, loopvar
FAAAAAAAAA:
;Get a random number and reset the random seed (dividing the seed
;by a prime number seems to make the numbers more diverse!)
;I usually make a variable TEMP and use it for general purposes
 ld logic_seed
 st b
 mov #$4e,acc
 mov #$6d,c
 mul
 st b
 ld c
 add #$39
 st logic_seed
 ld b
 addc #$30
 st temp
 st c
 ld temp
 st b
 mov #0, acc
 mul
 mov #7, b
 div
 ld c
 st logic_seed
;Make sure the number is between 1 and 6 (number mod 6 is between
;0 and 5
 ld temp
 st c
 mov  #6, b
 mov #0, acc
 div
 ld b
 st temp
 add #1
 st temp
;Set the answer (offset loopvar) to the random number
 mov #answer,0
 ld loopvar
 add 0
 st 0
 ld  temp
 st @R0
 ld loopvar
 add  #1
 st loopvar
 bne #4, FAAAAAAAAA
;Restore loopvar
 pop loopvar
 ret
get_keys:
 ld p3
 st logic_keys
 bp logic_keys,  6, GAAAAAAAAA
;MODE key has been pressed
 jmpf goodbye
GAAAAAAAAA:
 bp logic_keys,  7, HAAAAAAAAA
;SLEEP key has been pressed
;Wait for SLEEP key to be released
wloop:
 bp p3,  7, IAAAAAAAAA
 brf wloop
IAAAAAAAAA:
;Turn off the LCD screen
 mov #0,vccr
;This will keep the VMU "asleep" until you press the sleep button
sloop:
 set1 pcon,0
 bn p3,  7, JAAAAAAAAA
 brf sloop
JAAAAAAAAA:
;Wait for SLEEP key to be released
wloop2:
 bp p3,  7, KAAAAAAAAA
 brf wloop2
KAAAAAAAAA:
;Turn on the LCD screen
 mov #$80,vccr
HAAAAAAAAA:
 mov #block,0
 ld  selected
 add 0
 st 0
 ld @R0
 st shape
;Left key
 bp logic_keys,  2, LAAAAAAAAA
 ld shape
 sub #1
 st shape
wloop3:
 bp p3,  2, MAAAAAAAAA
 brf wloop3
MAAAAAAAAA:
LAAAAAAAAA:
;Right key
 bp logic_keys,  3, NAAAAAAAAA
 ld shape
 add #1
 st shape
wloop4:
 bp p3,  3, OAAAAAAAAA
 brf wloop4
OAAAAAAAAA:
NAAAAAAAAA:
 mov  #1, acc
 be shape,PAAAAAAAAA
 sub shape
 bp acc,7, PAAAAAAAAA
 mov #6, shape
PAAAAAAAAA:
 ld shape
 be  #6,QAAAAAAAAA
 sub  #6
 bp acc,7, QAAAAAAAAA
 mov #1, shape
QAAAAAAAAA:
 mov #block,0
 ld selected
 add 0
 st 0
 ld  shape
 st @R0
;Down key
 bp logic_keys,  1, RAAAAAAAAA
 mov #0, blinkstate
 mov #block,0
 ld  selected
 add 0
 st 0
 ld @R0
 st temp
 ld selected
 add #2
 st temp2
 mov #>shapes, ghp
 mov #<shapes, glp
 ld temp2
 st row
 ld turn
 st col
 ld temp
 st shape
 mov  #3,  height
 callf drawshape
 ld selected
 add #1
 st selected
wloop5:
 bp p3,  1, SAAAAAAAAA
 brf wloop5
SAAAAAAAAA:
 ld selected
 be  #3,TAAAAAAAAA
 sub  #3
 bp acc,7, TAAAAAAAAA
 mov #0, selected
TAAAAAAAAA:
RAAAAAAAAA:
;Up key
 bp logic_keys,  0, UAAAAAAAAA
 mov #0, blinkstate
 mov #block,0
 ld  selected
 add 0
 st 0
 ld @R0
 st temp
 ld selected
 add #2
 st temp2
 mov #>shapes, ghp
 mov #<shapes, glp
 ld temp2
 st row
 ld turn
 st col
 ld temp
 st shape
 mov  #3,  height
 callf drawshape
 ld selected
 sub #1
 st selected
wloop6:
 bp p3,  0, VAAAAAAAAA
 brf wloop6
VAAAAAAAAA:
 mov  #0, acc
 be selected,WAAAAAAAAA
 sub selected
 bp acc,7, WAAAAAAAAA
 mov #3, selected
WAAAAAAAAA:
UAAAAAAAAA:
;'A' key
 bp logic_keys,  4, XAAAAAAAAA
 mov #0, blinkstate
 mov #block,0
 ld  selected
 add 0
 st 0
 ld @R0
 st temp
 ld selected
 add #2
 st temp2
 mov #>shapes, ghp
 mov #<shapes, glp
 ld temp2
 st row
 ld turn
 st col
 ld temp
 st shape
 mov  #3,  height
 call drawshape
 ld  turn
 st  col
 call logic_showscore
 ld turn
 add #1
 st turn
 mov #0, selected
 call drawblock
wloop7:
 bp p3,  4, YAAAAAAAAA
 brf wloop7
YAAAAAAAAA:
XAAAAAAAAA:
 ret
waitend:
;This is called when you win or lose.
;First it draws the answer and then
;it waits for you to release the 'A' key.
;Then waits for you to press any key and exits.
 call drawanswer
waitloop:
 bp p3,  4, ZAAAAAAAAA
 brf waitloop
ZAAAAAAAAA:
waitloop2:
 ld p3
 bne #$ff, ABAAAAAAAA
 brf waitloop2
ABAAAAAAAA:
 jmpf goodbye
 ret
drawblock:
;Draws a row of blocks
 mov #>shapes, ghp
 mov #<shapes, glp
 mov #2, row
 ld turn
 st col
 ld block
 st shape
 mov  #3,  height
 call drawshape
 mov #>shapes, ghp
 mov #<shapes, glp
 mov #3, row
 ld turn
 st col
 ld block+1
 st shape
 mov  #3,  height
 call drawshape
 mov #>shapes, ghp
 mov #<shapes, glp
 mov #4, row
 ld turn
 st col
 ld block+2
 st shape
 mov  #3,  height
 call drawshape
 mov #>shapes, ghp
 mov #<shapes, glp
 mov #5, row
 ld turn
 st col
 ld block+3
 st shape
 mov  #3,  height
 call drawshape
 ret
drawanswer:
;Same as DRAWBLOCK except it draws horizontally and it draws
;the answer.
 mov #>shapes, ghp
 mov #<shapes, glp
 mov #1, row
 mov #1, col
 ld answer
 st shape
 mov  #3,  height
 call drawshape
 mov #>shapes, ghp
 mov #<shapes, glp
 mov #1, row
 mov #2, col
 ld answer+1
 st shape
 mov  #3,  height
 call drawshape
 mov #>shapes, ghp
 mov #<shapes, glp
 mov #1, row
 mov #3, col
 ld answer+2
 st shape
 mov  #3,  height
 call drawshape
 mov #>shapes, ghp
 mov #<shapes, glp
 mov #1, row
 mov #4, col
 ld answer+3
 st shape
 mov  #3,  height
 call drawshape
 ret
logic_showscore:
;Calculates the 'lines and dots' that are displayed after
;you push 'A'
;This also handles the 'YOU WIN' and 'GAME OVER' screens
 mov #0, white_pegs
 mov #0, black_pegs
 mov #12, row
 mov #0, loopvar
BBAAAAAAAA:
 mov #block,0
 ld  loopvar
 add 0
 st 0
 ld @R0
 st data
 mov #answer,0
 ld  loopvar
 add 0
 st 0
 ld @R0
 st olddata
 ld data
 bne  olddata, CBAAAAAAAA
 ld black_pegs
 add #1
 st black_pegs
 br DBAAAAAAAA
CBAAAAAAAA:
 push loopvar
 mov #0, loopvar
EBAAAAAAAA:
 mov #answer,0
 ld  loopvar
 add 0
 st 0
 ld @R0
 st olddata
 ld data
 bne  olddata, FBAAAAAAAA
 ld white_pegs
 add #1
 st white_pegs
FBAAAAAAAA:
 ld loopvar
 add  #1
 st loopvar
 bne #4, EBAAAAAAAA
 pop loopvar
DBAAAAAAAA:
 ld loopvar
 add  #1
 st loopvar
 bne #4, BBAAAAAAAA
 push black_pegs
 push white_pegs
GBAAAAAAAA:
 ld black_pegs
 be  #0, HBAAAAAAAA
 mov #>pegs, ghp
 mov #<pegs, glp
 ld row
 ld col
 mov #0, shape
 mov  #1,  height
 call drawshape
 ld black_pegs
 sub #1
 st black_pegs
 br IBAAAAAAAA
HBAAAAAAAA:
 ld white_pegs
 be  #0, IBAAAAAAAA
 ld white_pegs
 sub #1
 st white_pegs
 mov #>pegs, ghp
 mov #<pegs, glp
 ld row
 ld col
 mov #1, shape
 mov  #1,  height
 call drawshape
IBAAAAAAAA:
 ld row
 add  #1
 st row
 bne #16, GBAAAAAAAA
 pop white_pegs
 pop black_pegs
 ld black_pegs
 bne  #4, JBAAAAAAAA
 mov #>youwin, ghp
 mov #<youwin, glp
 mov #12, row
 mov #0, col
 mov #7, height
 mov #6, width
 mov #0, offset
 mov  #0,  xbnk
 call draw_graphic
 call waitend
 br KBAAAAAAAA
JBAAAAAAAA:
 ld turn
 bne  #10, KBAAAAAAAA
 mov #>logic_gameover, ghp
 mov #<logic_gameover, glp
 mov #12, row
 mov #0, col
 mov #7, height
 mov #6, width
 mov #0, offset
 mov  #0,  xbnk
 call draw_graphic
 call waitend
KBAAAAAAAA:
 ret
drawshape:
;Draws a single shape
 mov #0, xbnk
 push row
 push col
 ld blinkstate
 bne  #1, LBAAAAAAAA
 mov #0, shape
LBAAAAAAAA:
 ld height
 add #1
 st c
 ld row
 st b
 mov #0, acc
 mul
 ld c
 st row
 ld shape
 st c
 ld height
 st b
 mov #0, acc
 mul
 ld c
 st offset
 ld col
 st c
 mov  #2, b
 mov #0, acc
 div
 ld b
 st shift
 ld col
 st c
 mov #2, b
 mov #0, acc
 div
 ld c
 st col
 ld height
 st loopvar
MBAAAAAAAA:
 ld row
 add #1
 st row
 be  #15,NBAAAAAAAA
 sub  #15
 bp acc,7, NBAAAAAAAA
 ld row
 sub #16
 st row
 mov #1, xbnk
NBAAAAAAAA:
 call therest
 ld baseadd
 st 2
 ld col
 add 2
 st 2
 ld  data
 st @R2
 ld offset
 add #1
 st offset
 dbnz loopvar, MBAAAAAAAA
 pop col
 pop row
 ret
therest:
;THEREST of the above subroutine (having too much code
;in a single sub gives you an error)
 mov #0, c
 ld row
 mov #$2,b
 div
 mov #$10,b
 mul
 add #$80
 st baseadd
 clr1 acc,3
 be baseadd,OBAAAAAAAA
 clr1 baseadd, 3
 not1 baseadd, 1
 not1 baseadd, 2
OBAAAAAAAA:
 ld ghp
 st  trh
 ld glp
 st  trl
 ld  offset
 ldc
 st data
 ld shift
 bne  #1, PBAAAAAAAA
 ld baseadd
 st 2
 ld  col
 add 2
 st 2
 ld @R2
 st olddata
 ld data
 st c
 mov #16, b
 mov #0, acc
 div
 ld c
 st data
 ld olddata
 and  #%11110000
 st olddata
 ld data
 or  olddata
 st data
PBAAAAAAAA:
 ret
draw_graphic:
;General purpose drawing routine
;Draws ANY graphic anywhere!!!
QBAAAAAAAA:
 push width
 push col
 ld row
 be  #15,RBAAAAAAAA
 sub  #15
 bp acc,7, RBAAAAAAAA
 ld row
 sub #16
 st row
 mov #1, xbnk
RBAAAAAAAA:
 mov #0, c
 ld row
 mov #$2,b
 div
 mov #$10,b
 mul
 add #$80
 st baseadd
 clr1 acc,3
 be baseadd,SBAAAAAAAA
 clr1 baseadd, 3
 not1 baseadd, 1
 not1 baseadd, 2
SBAAAAAAAA:
TBAAAAAAAA:
 ld ghp
 st  trh
 ld glp
 st  trl
 ld  offset
 ldc
 st data
 ld baseadd
 st 2
 ld col
 add 2
 st 2
 ld  data
 st @R2
 ld col
 add #1
 st col
 ld offset
 add #1
 st offset
 dbnz width, TBAAAAAAAA
 pop col
 pop width
 ld row
 add #1
 st row
 dbnz height, QBAAAAAAAA
 ret

