; Minesweeper for SEGA Dreamcast VM

; $Id: minesweeper.s,v 1.30 2000/05/29 21:23:29 sgust Exp $

;;NICE to have, but not yet implemented because of major changes:
;; 0 field recursion
;; bigger, scrolling playfield
;; sync highscores with other VMs

; Copyright (C) 2000 by Soeren Gust, sgust@ithh.infoserv.de

; This program is free software; you can redistribute it and/or modify
; it under the terms of the GNU General Public License as published by
; the Free Software Foundation; either version 2 of the License, or
; (at your option) any later version.

; This program is distributed in the hope that it will be useful,
; but WITHOUT ANY WARRANTY; without even the implied warranty of
; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
; GNU General Public License for more details.

; You should have received a copy of the GNU General Public License
; along with this program; if not, write to the Free Software
; Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

; You can get the latest Version from http://soeren.infoserv.de


keyqstart	equ	$04	; first byte of keyboard queue
keyqend		equ	$0e	; last byte of keyboard queue
keyqin		equ	$0f	; pointer to insert into keyboard queue
keyqout		equ	$10	; pointer to read from keyboard queue
x		equ	$11	; x position for print
y		equ	$12	; y position for print
timelow		equ	$13	; low byte of gameclock
timehigh	equ	$14	; high byte of gameclock
timectl		equ	$15	; control byte for gameclock
mask1		equ	$16	; used by print
mask2		equ	$17	; used by print
char		equ	$18	; used by print
blinkflag	equ	$19	; counts and controls blinking in interrupts
blinkx		equ	$1a	; x position of blinking field in pixel
blinky		equ	$1b	; y position of blinking field in pixel
blinkchar	equ	$1c	; char to print for blinking field
curx		equ	$1d	; current x (0-5)
cury		equ	$1e	; current y (0-4)
screentoggle	equ	$1f	; which screen is displayed: title/highscore
unknownfields	equ	$20	; how many fields are visible
randlow		equ	$21	; bits 0-7 of random seed
randhigh	equ	$22	; bits 8-14 of random seed, highest bit unused
soundpointerl	equ	$23	; used by soundengine
soundpointerh	equ	$24	; used by soundengine
soundplaying	equ	$25	; used by soundengine
soundwait	equ	$26	; used by soundengine
bombs		equ	$27	; number of bombs hidden
keys		equ	$28	; key compare mask for keyboard irq
keyflags	equ	$29	; flags for A/B pressed on titlescreen
quitcount	equ	$2a	; counter for autoquit
lastkeyevent	equ	$2b	; store the latest key event for repeat
keyrepeat	equ	$2c	; counter/flag for key repeat
firststep	equ	$2d	; flag for first step

playfield	equ	$30	; - $4e: 30 byte playfield
; meaning of playfield:
; bit 7   flag
; bit 6   invisible
; bit 5   bomb
; bit 4-0 no of neighbor bombs

; constants
PF_LEFT		equ	0	; left screen position of playfield
PF_TOP		equ	0	; top screen position of playfield

; key numbers
KEY_UP		equ	1
KEY_DOWN	equ	2
KEY_LEFT	equ	3
KEY_RIGHT	equ	4
KEY_A		equ	5
KEY_B		equ	6
KEY_MODE	equ	7
KEY_SLEEP	equ	8
KEY_REL		equ	$80	; flag for key released

; bits in timectl
time_bit	equ	7
time_ovf	equ	2
time_disp	equ	1
time_run	equ	0
