
    ; VM -a- Sketch v1.4
    ;
    ; An Etch-a-Sketch simulator for the VM
    ;
    ; by Richard Munn / RAMTronics Software
    ;  http://go.to/rvmu
    ;  richard.munn@bigfoot.com
    ;
    ; portions based upon marcus comstedt's tiny tetris source
    ;  http://marcus.mangakai.org/dc/
    ;
    ; plotxy code taken from john maushammer's vmu gong source
    ;  http://www.tidalwave.net/~maushammer/vmu.html
    ;
    ; History:
    ; v1.0 - First beta release - on http://go.to/rvmu and within the Amiga VMU Devkit release 1.2
    ; v1.1 - Adjusted delay so that it runs at a better speed in SoftVMS v1.6
    ; v1.2 - The "draw spot" is now white when moving, to make it easier to find, and to add some realism!
    ; v1.3 - adjusted header title to the correct 32 characters 
    ;      - changed clock speed to Marcus' suggestion to save power
    ;      - adjusted code to allow for diagonal movement (hopefully!)
    ; v1.4 - diagonal movement really works now!

   ;; Main program

sketch:
   mov #$a3,ocr
   mov #$09,mcr
   mov #$80,vccr
   clr1 p3int,0
   clr1 p1,7
   mov #$ff,p3

   ld t0l
   st seed

   mov #24,cursx
   mov #16,cursy

   mov #1,delneed

   mov #<sketch_introscreen,trl ; Display title screen
   mov #>sketch_introscreen,trh
   callf setscr

.waitstart:
    callf getkeys
    and #$30    ; Wait for A+B
    bnz .waitstart

    callf clrscr

sketchloop:
  ld   cursx
  st   B
  ld   cursy
  callf plotxy
  callf docursor
  bz sketchloop
  ld   cursx
  st   B
  ld   cursy
  callf unplotxy
  ld   delneed
  bz  .nodel
  mov  #$70,acc
.delay:  dbnz acc,.delay      ; delay loop to temper the VMU's awesome speed
.nodel  jmpf sketchloop



docursor:
   callf getkeys      ; check for presses
   st keyspressed
   bn   keyspressed,4,.shake    ; A button press
   bn   keyspressed,5,.clear    ; B button press
   mov  #1, delneed
   mov  #0,b

   bn keyspressed,2,.moveleft

.ld   
   bn keyspressed,1,.movedown

.lu
   bn keyspressed,0,.moveup

.lr
   bn keyspressed,3,.moveright

.exit
   ld b 
   ret

.moveright:
   ld   cursx       ; make sure we don't go off screen
   be   #47,.exit  ; already at right edge? then don't move
   inc  cursx       ; move the dot to the right
   mov #1,b
   br .exit

.moveleft:
   ld cursx          ; check to make sure we don't go off-screen
   be   #0,.ld    ; it's already at left edge
   dec  cursx        ; move dot left
   mov #1,b
   br .ld  

.movedown:
   ld   cursy        ; make sure we don't go off screen
   be   #31,.lu   ; it's already at bottom edge
   inc  cursy        ; move dot down
   mov #1,b
   br .lu

.moveup:
   ld cursy          ; check to make sure we don't go off-screen
   be   #0,.lr    ; it's already at top edge
   dec  cursy        ; move dot up
   mov #1,b
   br .lr

.shake

  mov #0, delneed
  mov #50, loop

.shakelop
  clr1 PSW,1
  ld $01D
  set1 PSW,1
  st C

  callf random
  ror
  and #%00011111
  st B
  callf random
  add C
  and #%00001111
  add B
  st B
  callf random
  and #%00011111
  callf unplotxy

  dec loop
  ld loop
  bnz .shakelop

  br .exit

.clear
  callf clrscr
  br .exit

; changed: using merged functions located in bounce
;plotxy:
;unplotxy:
   
