; swampy command line:
; D:\dev\VM\VMU_All_Stars\games>LCdis SWAMPY.VMS ENTRY0x1129 ENTRY0x1155 ENTRY0x1188 ENTRY0x11ff ENTRY0x1273 ENTRY0x1280 ENTRY0x12ae ENTRY0x12c6 ENTRY0x1364 > SWAMPY_2.s	



; bugs:


; vision: freeze in game
;	-> game variable overwritten? -> interrupt not called?
;		..doesn't seem to be the reason
; !!! found problem: some data seems to be placed at 0xd9b,
; but it got no label assigned, so it's position must be hardcoded somewhere
; works with: .org $d9b
; ATTENTION: at d9b is a pointer table with TRL and TRH values
;	points to data of 2 bytes per unit
; okay, started to insert dynamic labels, but trying .org workaround first
; !!! does not work, again when all games are in
; okay, got it working, but in-game display only works, after switching off sound with B
;	-> maybe location of variable game, because after changing location, it doesn't work, again

; paper: freeze on ship crash
; LCdis command line:
; D:\dev\VM\VMU_All_Stars\games>LCdis PAPER.VMS ENTRY0x1115 ENTRY0x11f7 ENTRY0x1223 ENTRY0x1256 ENTRY0x12cd ENTRY0x137c ENTRY0x1432 ENTRY0x18b5 > PAPER_2.s	
; what's at 0x1321?

; snaky: wrong GFX, some pixels are not cleared
;	? but it worked standalone
;	-> maybe an alignment issue?	
;WARNING: NOT1 EXT,0 encountered at unexpected address 0a61.
;         This code calls a routine in the firmware and the return address
;         is unknown (not in FIRMWARECALL table).
;WARNING: NOT1 EXT,0 encountered at unexpected address 05e0.
;         This code calls a routine in the firmware and the return address
;         is unknown (not in FIRMWARECALL table).
;	-> found some unrecognized code behind NOT1 EXT,0
;		-> obviously, you can call the bios from everywhere
;		-> added ENTRYs to LCdis commandline:
;D:\dev\VM\VMU_All_Stars\games>LCdis SNAKY.VMS ENTRY0x0a61 ENTRY0x05e0 > SNAKY_2.s
;	-> modified handling of writeflash line 730
; !!!! finally works, I deleted zero bytes which in fact where used as an empty screen image
;	just like clrscr
;	hint: L0500 and clrscr replacement wastes memory

;

; spaceinvaders: swapped colors in game
;	-> NO, it is randomly choosen by game

; minesweeper doesn't react on input in title
;	-> keypress timer interrupt dispatcher was wrong


; games per screen:
;	
;	screen 1: fatrain, tetris, spaceinvaders, paper
;
;	screen 2: swampy, slidepuzzle, 4wins, logic
;
;	screen 3: minesweeper, vision, bounce
;
;	screen 4: idoudo, sketch, snaky



	.include "sfr.i"

	;; Game variables

;	.include "tetris_def.i"
;	.include "minesweeper_def.i"
;	.include "sketch_def.i"
;	.include "idoudo_def.i"
;	.include "spaceinvaders_def.i"
;	.include "slidepuzzle_def.i"
;	.include "snaky_def.i"
;	.include "4wins_def.i"
;	.include "logic_def.i"
	.include "vision_def.i"
;	.include "fatrain_def.i"
;	.include "paper_def.i"
;	.include "swampy_def.i"
;	.include "bounce_def.i"

; this must not be overwritten by the games
;game				equ	$70
;game				equ	$80
game				equ	$80

; games which don't use the game varaible can take a dummy bit
game_dummy			equ	0
game_tetris			equ	0
game_slidepuzzle	equ 0
game_snaky			equ 0
game_logic			equ 0
game_bounce			equ 0


game_idoudo			equ 1
game_spaceinvaders	equ 2
game_minesweeper	equ	3
game_4wins			equ 4
game_vision			equ 5
game_fatrain		equ 6
game_paper			equ 6
game_swampy			equ 6
game_sketch			equ 7


        ;; bits in keys
pressed_sleep   equ     7       ; same like port 3, if 0: button pressed
pressed_mode    equ     6
pressed_b       equ     5
pressed_a       equ     4
pressed_right   equ     3
pressed_left    equ     2
pressed_down    equ     1
pressed_up      equ     0

; global seed, used by tetris and sketch
seed = $3c			; random seed

	;; Reset and interrupt vectors
	
; reset
	.org	0
	jmpf	vision

; external irq 0
	.org	$3
	bn game, game_fatrain, .skip_fat
	CLR1   I01CR, 1
.skip_fat:	
	jmp	nop_irq

; external irq 1
	.org	$b
	jmp	nop_irq
	
; timer/counter 0 low 8 bit mode overflow
	.org	$13
	jmpf	int_13

; count clock
	.org	$1b
	jmpf	int_1b

	
; timer/counter 0 high / 16 bit mode overflow
	.org	$23
	jmpf	int_23


; timer/counter 1 overflow
	.org	$2b
	jmpf	int_2b

; SIO0
	.org	$33
	jmpf	nop_irq

; SIO1
	.org	$3b
	jmp	nop_irq

; RFB
	.org	$43
; changed: actually in the games of Omar Cornut,
; there is 4 times "SET1   $1ff, 7"	and a fall through
	bp game, game_fatrain, .skip_nofat	
	jmp	nop_irq
.skip_nofat:
	SET1   $1ff, 7
	SET1   $1ff, 7

; port3 change: key pressed
	.org	$4b
	clr1	p3int,p3iflag		; clear flag
	bp game, game_4wins, nop_irq
	bp game, game_fatrain, nop_irq
	clr1	p3int,p3ie		; disable further interrupts
nop_irq:
	reti
	
;;; minesweeper {

; Firmware calls

	.org	$100
writeflash
	not1	ext,0
	jmpf	writeflash
	ret

	.org	$110
verifyflash
	not1	ext,0
	jmpf	verifyflash
	ret

	.org	$120
readflash
	not1	ext,0
	jmpf	readflash
	ret

;;; } minesweeper


; Clock irq: Count time, do housekeeping
	.org	$130
	
int_1b:
	push	ie
	clr1	ie,mastie
	not1	ext,0
	jmpf	int_1b
; it only works with this workaround (can't find a free memory reagon)
; AND only as standalone, not in allstars
; why???
;	bn game, game_vision, .skip_v
 	jmpf		L0139
.skip_v	
	pop	ie
	bn game, game_minesweeper, .skip_m
;	callf	myclockint
.skip_m:
	reti
		
; Leave game
	.org	$1f0
goodbye:	
	not1	ext,0
	jmpf	goodbye


; Header
	.org	$200
; Name
	.byte	"VMU games #1    "      ; 16 letters
; Description
	.byte	"VMU games #1 by www.rockin-b.de "      ; 32 letters
; Creator application
	.byte	"aslc86k         "

	;; Icon header
	
	.org	$240
; Icon header: number of frames
	.word	3
; Icon header: speed
	.word	10
; Icon header: eyecatch
	.word	0
; Icon header: crc, unused in game
	.word	0
; Length of file data
	.word	end,0
; Reserved
	.byte	0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0

	;; Icon palette
	
	.org	$260

	.word	$F000,$F800,$F080,$F880,$F008,$F808,$F088,$FCCC
	.word	$F888,$FF00,$F0F0,$FFF0,$F00F,$FF0F,$F0FF,$FFFF

	;; The "Rockin'-B" icon for VMU file browser on Dreamcast 

	.org	$280

	.include "rbicon.i"
	
	;; Main program

	.org	$680

;	.include "vision_game.s"
;	.include "vision_data.i"

start:

;	jmpf vision
	.include "vision_game.s"
	.include "vision_data.i"




;;	interrupt dispatcher

int_13:
	bn game, game_minesweeper, .skip_m
;	jmpf	timer0l_irq
.skip_m:
	reti

int_23:
	bn game, game_fatrain, .skip_fat
	CLR1   T0CON, 3
.skip_fat:	
	bn game, game_minesweeper, .skip_m
;	jmpf	timer0h_irq
.skip_m:
	reti

int_2b:
	bn game, game_minesweeper, .skip_m
;	jmpf	sound_irq
.skip_m:
	reti

;	.include "common.s"
quit:
    jmpf goodbye


	.cnop	0,$200		; pad to an even number of blocks
end
